Is Restrict Content Pro compatible with WordPress 5.0?

Yes, Restrict Content Pro is compatible with WordPress 5.0 and the new Gutenberg editor. Content restrictions continue to work in the same way as they did in WordPress 4.9 with the classic editor. A "restrict this content" metabox will appear below the Gutenberg editor, and any content placed in the editor will be restricted if the user viewing the page does not meet the requirements.